function [B,G] = expbeliefs(B,G)
% EXPBELIEFS Move beliefs from logspace to standard range.
%
% [B,G] = EXPBELIEFS(B,G) where B are the node beliefs and G is a
% cell of edge beliefs.

    
% Jerod Weinman
% jerod@acm.org
    
% $Id: expbeliefs.m 1 2009-05-07 13:41:00Z weinman $
 
% Jerod Weinman
% jerod@acm.org
% Copyright 2004, 2008, 2009
 
%    This file is part of Matlab GridCRF.
%
%    Matlab GridCRF is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    Matlab GridCRF is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with Matlab GridCRF.  If not, see <http://www.gnu.org/licenses/>.
  
  B = exp(B);
  
  % re-normalize
  Z = sum(B);
  B = B./Z(ones(1,size(B,1)),:);

  if nargin==2
	E = find(~cellfun('isempty',G));
	
	for e=E(:)'
	  
	  be = exp(G{e});
	  
	  G{e} = be./sum(be(:));
	  
	end;
  end;
